/**
 *
 * Copyright (C) 2013 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/
#ifndef PARAMETERS_H
#define PARAMETERS_H

#include <iostream>
#include <string>
#include "Vector.h"
#include "Texture.h"

/**
 * class Parameters
 * 
 */

class Parameters 
{
 public:
  Parameters() ;
  Parameters( const Vector& , Texture* , int  ) ;
  //  Parameters( const Vector& , const Vector& , int  ) ;
  Parameters( const Vector& , Texture* , int ,const Vector& , const Vector& , double=0.0 ) ;// stocker la distance... cela évite de la recalculer
  //  Parameters( const Vector& , const Vector& , int ,const Vector& , const Vector& , double=0.0 ) ;
  ~Parameters() { /*delete c;*/ }
  Parameters ( const Parameters& );

  int getReflection() const;
  double getMaxColorChannel() const;
  Vector getPosition() const;
  Vector getEmission() const;
  Vector getColor() const;
  //  Vector getColorPt(const Vector&) const;
  Vector getNormal() const;
  double getDistance() const;
  Texture* getTexture() const;

  void setReflection(int);
  void setMaxColorChannel(double);
  void setPosition(const Vector&);
  void setEmission(const Vector&);
  void setColor(const Vector&);
 void setTexture(Texture*);
  void setNormal(const Vector&);
  void setDistance(double);
  

  bool equals(const Parameters& ) const;
 protected:

  Vector p, e, n, color;   //!< position, emission, normal, color
  double f; //!< Maximum color channel value
  int refl;      //!< Reflection type
  double d;
  Texture *c;

 private:
 

};

#endif // PARAMETERS_H
