/**
 *
 * Copyright (C) 2013 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/
#ifndef ROTATION_H
#define ROTATION_H

#include "Vector.h"
#include "Parameters.h"
#include "Node.h"
#include "Intersections.h"
#include "Ray.h"
#include "Transformation.h"
#include "Matrice.h"

class Rotation : public Transformation
{
 private:
  Vector axe;
  double angle;
  Matrix<double> m;
  Matrix<double> mInverse;
 public:
  Rotation(){}
  Rotation(const Parameters&, const Node*, const Vector&, double);
  ~Rotation(){}
  int Intersect(const Ray&, Intersections& ) const;
  int Inside (const Vector& ) const;
  int Inside (const Node& ) const;

};


#endif //ROTATION_H



