/**
 *
 * Copyright (C) 2013 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/
#ifndef TORE_H
#define TORE_H

#include "Vector.h"
#include "Parameters.h"
#include "Node.h"
#include "Intersections.h"
#include "Ray.h"
#include "Polynomial.h"
/**
 * class Tore
 * 
 */

class Tore : public Node
{
 public:
  Tore (const Parameters&,const Vector& , const Vector&  , double , double);//centre,axe,r1,r2
  Tore(const Tore& );
  ~Tore ( ) {}

  int Inside (const Vector& p ) const;
  int Inside (const Node&) const;
  int Intersect(const Ray&, Intersections&) const;


 protected:

 private :
  Vector centre;
  Vector axeZ, axeX,axeY;
  double r1;
  double r2;
};

#endif // TORE_H
