/**
 *
 * Copyright (C) 2013 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/
#include "And.h"

// Constructors/Destructors
//  

And::And (const Node* n1, const Node* n2 ):Operator(n1,n2){}

And::And (const And& o ):Operator(o){}

//  
// Methods
//  


int And::Inside (const Vector& p ) const{
  return (n1->Inside(p) && n2->Inside(p));
}

int And::Inside (const Node&) const{
  return 1;
}

/**
 * Retourner données réccuperées du point le plus proche de l'origine de Ray
 */
int And::Intersect(const Ray& ray, Intersections& l) const{
  
  Intersections i1, i2, iTmp;
  int result1 = n1->Intersect(ray,i1);
  int result2 = n2->Intersect(ray,i2);
  int result = 0;
  if(result1 && result2){


   
        if(i2.first().getDistance()<i1.first().getDistance() and i2.last().getDistance()>i1.first().getDistance()){
      l.append(i1.first());
      result =  1;
    }
if(i1.first().getDistance()<i2.first().getDistance() and i1.last().getDistance()>i2.first().getDistance()){
      l.append(i2.first());
      result = 1;
    }
if(i2.last().getDistance()<i1.last().getDistance() and i2.last().getDistance()>i1.first().getDistance()){
      l.append(i2.last()); 
      result = 1;
    }


  }
  return result;
}


// Accessor methods
//  


// Other methods
//  


