/**
 *
 * Copyright (C) 2013 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/
#include "Parameters.h"

// Constructors/Destructors
//  

Parameters::Parameters(){}



Parameters::Parameters ( const Vector& e, Texture* c, int refl)  {
  Parameters::e = e;
  Parameters::c = c;
  Parameters::refl = refl;
  Parameters::f=c->getColor(0)>c->getColor(1) && c->getColor(0)>c->getColor(2) ? c->getColor(0) : c->getColor(1)>c->getColor(2) ? c->getColor(1) : c->getColor(2);
  Parameters::n = Vector();
  Parameters::p = Vector();
  Parameters::d = 0.0;
  Parameters::color = c->getColor();
  // std::cout<<"B:"<<color<<std::endl;
}
/*Parameters::Parameters ( const Vector& e, const Vector& c, int refl)  {
  Parameters::e = e;
  Parameters::c = new TextureDefault(c);
  Parameters::refl = refl;
  Parameters::f=c[0]>c[1] && c[0]>c[2] ? c[0] : c[1]>c[2] ? c[1] : c[2];
  Parameters::n = Vector();
  Parameters::p = Vector();
  Parameters::d = 0.0;
  }*/

Parameters::Parameters ( const Vector& e, Texture* c, int refl, const Vector& n, const Vector& p, double d)  {
  Parameters::e = e;
  Parameters::c = c;
  Parameters::refl = refl;
  Parameters::f=c->getColor(0)>c->getColor(1) && c->getColor(0)>c->getColor(2) ? c->getColor(0) : c->getColor(1)>c->getColor(2) ? c->getColor(1) : c->getColor(2);
  Parameters::n=n;
  Parameters::p=p;
  Parameters::d=d;
  Parameters::color =c->getColorPt(p);
  //std::cout<<"A:"<<color<<std::endl;
}

/*Parameters::Parameters ( const Vector& e, const Vector& c, int refl, const Vector& n, const Vector& p, double d)  {
  Parameters::e = e;
  Parameters::c = new TextureDefault(c);
  Parameters::refl = refl;
  Parameters::f=c[0]>c[1] && c[0]>c[2] ? c[0] : c[1]>c[2] ? c[1] : c[2];
  Parameters::n=n;
  Parameters::p=p;
  Parameters::d=d;
  }*/


Parameters::Parameters (const Parameters& tmp ) {
  Parameters::e = tmp.e;
  Parameters::c = tmp.c;
  Parameters::refl = tmp.refl; 
  Parameters::f = tmp.f;
  Parameters::n = tmp.n;
  Parameters::p = tmp.p;
  Parameters::d = tmp.d;
  Parameters::color = tmp.color;
  //  std::cout<<"C:"<<color<<" "<<tmp.color<<" "<</*c->getColorPt(p)<<*/std::endl;
}


int Parameters::getReflection() const{ return refl; }

double Parameters::getMaxColorChannel() const{ return f; }

Vector Parameters::getPosition() const{ return p; }

Vector Parameters::getEmission() const{ return e; }

Vector Parameters::getColor() const{ return color; }

//Vector Parameters::getColorPt(const Vector& pt) const{ return c->getColorPt(pt); }

Texture* Parameters::getTexture() const{ return c; }

Vector Parameters::getNormal() const{ return n; }

double Parameters::getDistance() const{ return d; }

void Parameters::setReflection(int r) { this->refl=r; }

void Parameters::setMaxColorChannel(double f) { this->f=f; }

void Parameters::setPosition(const Vector& p) { this->p=p; }

void Parameters::setEmission(const Vector& e) { this->e=e; }

void Parameters::setColor( const Vector& color) { this->color= color; }

void Parameters::setTexture( Texture* c) { this->c= c; }



void Parameters::setNormal(const Vector& n) { this->n=n; }

void Parameters::setDistance(double d) { this->d=d; }

bool Parameters::equals(const Parameters& p) const{ return ( this->p==p.p ); } //peu être inclure une approximation ?
//  
// Methods
//  

// Accessor methods
//  


// Other methods
//  


